import sys, os
import cds_script
import ui
import pysvn


# This is a cforge command (script file)
# this will be run as ironpython script.
# the filename of this script is automatically the corresponding cforge command 
# with some magic functions you can easily integrate it nicely into cforge tool

# cforge_usage: 
# here you can return an array of all possible arguments and options that can 
# be passed to this command script
def cforge_usage():
    help = [ 
	    ["<path to CODESYS project>", "---"]
    ]

    return help

if len(sys.argv) <= 1:
    print("Oh, there are no arguments. Perhaps you forgot something?")
    sys.exit()

folder = sys.argv[1]
stat = pysvn.svn_get_stat(folder)
config = ui.Dialog("Commit", Credentials=True, Info=True, InfoText=stat, Message=True)

if config != None:
	scriptpath = os.path.abspath(os.path.dirname(sys.argv[0]))
	scriptname = os.path.join(scriptpath, "action.svn.commit.py")
	scriptargs = "%s %s %s %s" % (config["user"], config["pass"], folder, config["msg"])

	cds_script.RunCodesysWithScript(scriptname, scriptargs, False)
